/*
 * Virtual Drum Machine - Rhythm Compiler runtime library
 * This project is in the public domain.
 *---
 * The card stuff include file
 */

#ifndef _CARD_H_
#define _CARD_H_

#define CARD_NO_SOUND	0
#define CARD_MONO	1
#define CARD_STEREO	2

#define CARD_DEFAULT_DEV	"/dev/dsp"
#define CARD_DEFAULT_FREQ	44100

typedef struct {
  /* setup before init_card */
  int mode;
  char *device;
  int frequency;

  /* setup by init_card */
  int fd;
} CARD;

int init_card(CARD *);
void close_card(CARD *);
void card_play(CARD *, void *, int);

#endif /* _CARD_H_ */
