/*
 * Virtual Drum Machine - Rhythm Compiler runtime library
 * This project is in the public domain.
 *---
 * The mixer stuff include file
 */

#ifndef _MIXER_H_
#define _MIXER_H_

#define MIXER_MONO	0
#define MIXER_STEREO	1
#define MIXER_SEPARATED	2

#include "sample.h"

#include <string.h>

typedef struct {
  short *data;
  int size;		/* in bytes */
  int proceeded_size;	/* in bytes */

  double vol;		/* 1 = full volume */
  double pan;		/* 0 = center, -1 = full left, 1 = full right */
} CHANNEL;

typedef struct CHANNEL_LIST {
  CHANNEL channel;
  struct CHANNEL_LIST *next;
} CHANNEL_LIST;

typedef struct {
  CHANNEL_LIST *list;
  CHANNEL_LIST *free_list;
  void *buffer;		/* we mix in double */
  void *buffer_out;	/* we output in signed hort */
  int buffer_size;	/* in samples */

  /* default value setup before init_mixer */
  double tempo;
  int mode;
  int frequency;
} MIXER;

int init_mixer(MIXER *);
void close_mixer(MIXER *);

void mix_some(MIXER *, int);

void mixer_add_channel(MIXER *, SAMPLE *, double, double);

extern double vol; /* the main volume */

#endif /* _MIXER_H_ */
