/*
 * Virtual Drum Machine - Rhythm Compiler runtime library
 * This project is in the public domain.
 *---
 * The sample stuff
 */

#include "sample.h"

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/mman.h>

/* load a wav file, 44100 16b mono assumed, no check done */
/* only load simple wav file, no compression, must be 16b little endian signed data */
void init_sample(SAMPLE *s, char *file)
{
  int fd;
  struct stat sb;

  /* default values */
  s->vol = 1;
  s->pan = 0;

  fd = open(file, O_RDONLY);
  if (fd == -1)
    goto error;
  if (fstat(fd, &sb)==-1)
    goto error;

  if (sb.st_size < 45) {
    close(fd);
    free(s);
    fprintf(stderr, "error with a sample, the file length is %d (should be at least 45)\n", (int)sb.st_size);
    exit(1);
  }

  s->size = sb.st_size - 44;
  s->buffer = mmap(0, sb.st_size, PROT_READ, MAP_SHARED, fd, 0);
  if (s->buffer == (void *)-1)
    goto error;
  s->buffer += 44;

  close(fd);
  return;

error:
  perror(file);
  if (fd != -1) close(fd);
  exit(1);
}

void close_sample(SAMPLE *s)
{
  if (munmap((unsigned char *)s->buffer-44, s->size+44) == -1)
    perror("munmap");
}
