/*
 * Virtual Drum Machine - Rhythm Compiler runtime library
 * This project is in the public domain.
 *---
 * The sound stuff include file
 */

#ifndef _SOUND_H_
#define _SOUND_H_

#include "wav.h"
#include "mixer.h"
#include "card.h"
#include "sample.h"

typedef struct {
  MIXER mixer;
  CARD card;
  WAVE wav;
} SOUND;

int init_sound(SOUND *);
void play_some_sound(SOUND *, int);
void finalize_sound(SOUND *);
void put_note(SOUND *, SAMPLE *, double, double);
void close_sound(SOUND *);

#endif /* _SOUND_H_ */
