/* this part of this project is written by Stephan Beyer,2002 */
/* it's my first WAV code, so NO WARRANTY .. */
/* feel free to optimize or whatever .... */

/* modified by Sed */

#include "wav.h"

#include <stdlib.h>
#include <stdio.h>

/* transform an int into a little endian buffer */
unsigned char *itole(unsigned int l, unsigned char *t)
{
  *t = l & 255;
  *(t+1) = (l >>  8) & 255;
  *(t+2) = (l >> 16) & 255;
  *(t+3) = (l >> 24) & 255;
  return t;
}

/* transform a short into a little endian buffer */
unsigned char *stole(unsigned short l, unsigned char *t)
{
  *t = l & 255;
  *(t+1) = (l >>  8) & 255;
  return t;
}

/* return 0 if ok, otherwise -1 */
int init_wave (WAVE *w)
{
  unsigned char t[4];
  short bit_resolution = 16;

  w->length = 0;

  if (w->mode == WAV_DO_NOTHING)
    return 0;

  if (!(w->file = fopen(w->filename, "wb"))) {
    perror(w->filename);
    return -1;
  }

  if (w->mode == WAV_SAVE_RAW2) {
    if (!(w->file2 = fopen(w->filename2, "wb"))) {
      perror(w->filename2);
      return -1;
    }
  }

  if (w->mode == WAV_SAVE_RAW || w->mode == WAV_SAVE_RAW2)
    return 0;

  if (fwrite("RIFFsizeWAVEfmt ", 16, 1, w->file)	!= 1) goto error;	/* "size" will be set after writing */
  if (fwrite(itole(16, t), 4, 1, w->file)		!= 1) goto error;	/* length of fmt chunk (16) */
  if (fwrite(stole(1, t), 2, 1, w->file)		!= 1) goto error;	/* 1 => PCM */
  if (fwrite(stole(w->channels, t), 2, 1, w->file)	!= 1) goto error;
  if (fwrite(itole(w->frequency, t), 4, 1, w->file)	!= 1) goto error;
  if (fwrite(itole(w->frequency * w->channels * (bit_resolution/8), t), 4, 1, w->file)	!= 1) goto error;
  if (fwrite(stole(w->channels * (bit_resolution/8), t), 2, 1, w->file)			!= 1) goto error;
  if (fwrite(stole(bit_resolution, t), 2, 1, w->file)	!= 1) goto error;
  if (fwrite("datasize", 8, 1, w->file)			!= 1) goto error;	/* size set after writing */

  return 0;

error:
  perror(w->filename);
  return -1;
}

/* setting size (if WAVE stuff) and close file */
void close_wave (WAVE *w)
{
  unsigned char t[4];

  if (w->mode == WAV_DO_NOTHING)
    return;

  if (w->mode == WAV_SAVE_RAW || w->mode == WAV_SAVE_RAW2)
    goto do_close;

  /* WAVE size */
  if ((fseek(w->file, 4, SEEK_SET)) != 0) goto error;
  if (fwrite(itole(w->length+36, t), 4, 1, w->file) != 1) goto error;

  /* data chunk size */
  if ((fseek(w->file, 40, SEEK_SET)) != 0) goto error;
  if (fwrite(itole(w->length, t), 4, 1, w->file) != 1) goto error;

do_close:
  if (fclose(w->file) == EOF) goto error;
  if (w->mode == WAV_SAVE_RAW2)
    if (fclose(w->file2) == EOF) goto error2;
  return;

error:
  perror(w->filename);
  return;

error2:
  perror(w->filename2);
  return;
}

void wave_play (WAVE *w, void *buf, int size)
{
  if (w->mode == WAV_SAVE_RAW2) {
    if (fwrite(buf, size/2, 1, w->file) != 1) {
      perror(w->filename);
      exit(1);
    }
    if (fwrite((unsigned char *)buf+size/2, size/2, 1, w->file2) != 1) {
      perror(w->filename2);
      exit(1);
    }
    return;
  }

  if (fwrite(buf, size, 1, w->file) != 1) {
    perror(w->filename);
    exit(1);
  }

  if (w->mode == WAV_SAVE_WAV)
    w->length += size;
}
