/*
 * Virtual Drum Machine - Rhythm Compiler program
 * This project is in the public domain.
 *---
 * The error definition include file
 */

#ifndef _ERROR_H_SED_	/* maybe _ERROR_H_ is already defined by the system */
#define _ERROR_H_SED_

/* the error types */
#define		NO_ERROR		0
#define		ENVIRONMENT_INIT	1
#define		COMPILER_INIT		2
#define		RHYTHM_INIT		3
#define		COMPILE			4

/* error codes (dummy order, the best one :) */
#define		NO_ERROR			0
#define		FILE_NOT_FOUND			1
#define		NOTE_EXPECTED			2
#define		BAD_INSTRUMENT_NAME		3
#define		GETLINE_ERROR			4
#define		CANT_CREATE_FILE		5
#define		INPUT_FILE_ALREADY_DEFINED	6
#define		BAD_OPTION_NAME			7
#define		OUTPUT_FILE_ALREADY_DEFINED	8
#define		FILE_NAME_EXPECTED		9
#define		C_ONLY_ALREADY_DEFINED		10
#define		IMPOSSIBLE_CREATE_TEMP_NAME	11
#define		FORK_ERROR			12
#define		GCC_ERROR			13
#define		EXEC_ERROR			14
#define		INPUT_FILE_REQUIRED		15
#define		CONFIG_FILE_NOT_FOUND		16
#define		NO_CONFIG_FILE_NAME		17
#define		BAD_CONFIG_FILE_NAME		18
#define		ENV_INC_DIR_NOT_SET		19
#define		ENV_LIB_DIR_NOT_SET		20
#define		ERROR_WRITING_FILE		21
#define		PARSE_ERROR			22
#define		PARSER_BAD_INIT_NOTE		23
#define		NO_C_LINE_INSIDE_POLY		24

void error(int, int, int, char **);
void usage(char *);

#endif /* _ERROR_H_SED_ */
